//
// $Id: cluster.cpp,v 1.1.1.1 2005/05/06 01:15:31 xanguera Exp $
//
#include <iostream>

#include "global.h"
#include "hmm.h"
#include "HTKfile.h"

int 
main(int argc, char *argv[]) {
  if(argc < 7) {
    printf("USAGE: %s K M DIM MD input_data_file output_cluster_file [spnsp_file]\n", argv[0]);
    exit(0);	
  }
  int K = atoi(argv[1]);	// number of initial clusters
  int M = atoi(argv[2]);	// number of initial Gaussians
  int DIM = atoi(argv[3]);	// DIMension of feature vector
  int MD = atoi(argv[4]);	// Minimum Duration of segment (in frames)

  // Create the HTK file object and read in the data
  HTKfile htkf;
  htkf.init();
  htkf.open(argv[5]);

  if(argc == 8)			// assume speech seg file given
    htkf.readUEM(argv[7]);	// reads in speech seg file

  // Do Cepstral Mean and variance Normalization 
  //int cmnWin = 300;
  //htkf.run_CMN(cmnWin);
  //std::cerr << "Done running CMN(" << cmnWin << ")" << std::endl;

  HMM hmm(K, M, DIM, MD);
  chunk *first;
  //hmm.InitializeXBIC(htkf, &first, K);
  //hmm.Initialize(htkf, &first,"init.segs");
  hmm.Initialize(htkf, &first);
  hmm.Train_HMM(htkf, first);

  for(int loop=0; loop < N_LOOPS_ADAPT-N_LOOPS_ADAPT2;loop++) {
    delete first;			// forget this segmentation
    hmm.segment(htkf,&first);
  hmm.Write(argv[6], first, htkf);
    hmm.Train_HMM(htkf,first);
  }

  // segment and re-train a set number of times before clustering
  int CANDIDATE = 1;
  int cd1, cd2;
  // Now Merging will start
  CANDIDATE=1;
  while(CANDIDATE) {
    CANDIDATE = 0;
    for (int loop=0;loop<N_LOOPS_ADAPT2;loop++){
      delete first;
      hmm.segment(htkf, &first);	// Viterbi segmentation
      hmm.Train_HMM(htkf, first);	// Retrain the HMMs
    }
    // Look for a pair of clusters to merge
    CANDIDATE = hmm.Find_Best(&cd1, &cd2, first, htkf);
    if(CANDIDATE){		// found a merge-pair
      hmm.Merge(cd1, cd2, first, htkf);
    }else{			// nothing left to merge, we're done.
      hmm.Write(argv[6], first, htkf);
    }
  }
}
