//
// $Id: gmm.h,v 1.1.1.1 2005/05/06 01:15:31 xanguera Exp $
//
#ifndef __GMM_H__
#define __GMM_H__

#include "global.h"

class Gaussian {
 public:
  int DIM;
  float *Mean;
  float *Var;
  Gaussian();
  ~Gaussian();
  void Initialize(int dim);
  float Log_Likelihood(float *feature);
  void PrintGaussian(FILE *fout);
  void ReadGaussian(FILE *fin, const int d);
};

class GMM {
 public:
  int M;
  int DIM;
  float *Weight;
  Gaussian *gArray;	
  float *local_lkld;
  float lkld;
  GMM();
  GMM(const GMM &gmm);
  ~GMM();
  void Copy(GMM temp_gmm);
  float Train(float *data, int nSamples);
  float Evaluate(float *data, int nSamples);
  void Initialize(int M, int dim);
  void Initialize(float *data, int count);
  float Log_Likelihood(float *feature);
  float Log_Add(float log_a, float log_b);
  void PrintGMM(FILE *fout);
  void ReadGMM(FILE *fin, const int d);
};

#endif

