//
// $Id$
//
#ifndef __WINDOWBOUNDS__
#define __WINDOWBOUNDS__

// A simple class to hold the boundaries of a "window". A window refers to
// a set of contiguous frames of speech. The windowBounds class contains 
// the index of the beginning frame and the end frame of the window.
class windowBounds {
  public:
    windowBounds(): beg(0), end(0) {}
    windowBounds(unsigned long b, unsigned long e): beg(b), end(e) {}

    // Set the boundaries base on a window whose length is given by
    // 'winlen', is centered at 'center', with a max index of 'maxindex'.
    // (The min index is assumed to be 0.) This method handles boundary cases
    // such as asking for a window of 10 frames with a center at frame 0.
    // Returns 'true' if the bounds were set successfully, 'false' otherwise.
    bool setBounds(unsigned long center,
		   unsigned long winlen,
		   unsigned long maxindex);


    unsigned long getBeg(){return beg;}
    unsigned long getEnd(){return end;}

 private:
    unsigned long beg;
    unsigned long end;

};

#endif //__WINDOWBOUNDS__
