#!/usr/bin/env python
# -*-Mode:Python-*-
#
#
import sys, string, time, commands, os, tempfile, datetime, glob, re
from optparse import OptionParser

def importCode(code, name):
    import imp
    module = imp.new_module(name)
    #sys.modules[name] = module
    exec code in module.__dict__
    return module

# This class (Xlator) is taken from The Python Cookbook recipe 3.14
class Xlator(dict):
    """ All-in-one multiple-string-substitution class """
    def __init__(self,theDict):
        # call base class __init__() function
        dict.__init__(self,theDict)
        # Build re object based on the keys of the dictionary
        self.regex = re.compile("|".join(map(re.escape,self.keys())))
        
    def __call__(self,match):
        """Handler invoked for each regex match """
        return self[match.group(0)]

    def xlat(self, text):
        """ Translate text, returns the modified text."""
        return self.regex.sub(self, text)

def docmd(cmd):
    result = commands.getstatusoutput(cmd)
    if result[0] != 0:
        sys.exit("Error running: %s:\n%s"%(cmd,result[1]))
    return result[1]
        
usage = '''%prog [options] config_file

required:
   config_file     a file containing all config variables '''

genrun = "./scripts/gen-runfile.py"
genscr = "./scripts/gen-scorefile.py"

#########################################
####  main
#########################################
if __name__ == '__main__':
    
    cmdline = string.join(sys.argv)

    op = OptionParser(usage=usage)
    options,args = op.parse_args(sys.argv[1:])

    if len(args) != 1:
        op.print_help()
        sys.exit(1)

    # Read in the config file
    fh = open(args[0])
    configMod = importCode(fh,"config")
    fh.close()

    # Generate the run file and the score file
    cmd = genrun + " " + args[0]
    docmd(cmd)
    cmd = genscr + " " + args[0]
    docmd(cmd)

    # Generate the experiment run file

    # Remove any existing experiment run file (shouldn't be needed)
    if os.path.exists(configMod.exprunfile):
        cmd = "rm "+configMod.exprunfile
        docmd(cmd)
        
    # Generate the run-command command-line
    cmd = "echo run-command %s -f %s > %s"%(configMod.rcparams,
                                            configMod.RF_OUTFILE,
                                            configMod.exprunfile)
    docmd(cmd)
    # Generate the command line to run the scoring script
    cmd = "echo /bin/sh %s >> %s"%(configMod.scorecmdfile,
                                   configMod.exprunfile)
    docmd(cmd)
    # Make the experiment run file executable
    cmd = "chmod ugo+x "+configMod.exprunfile
    docmd(cmd)
    
    sys.exit(0)
    
