#!/usr/bin/env python
# -*-Mode:Python-*-
#
#
import sys, string, time, commands, os, tempfile, datetime, glob
import commands, re, os
from optparse import OptionParser

def importCode(code, name):
    import imp
    module = imp.new_module(name)
    #sys.modules[name] = module
    exec code in module.__dict__
    return module

# This class (Xlator) is taken from The Python Cookbook recipe 3.14
class Xlator(dict):
    """ All-in-one multiple-string-substitution class """
    def __init__(self,theDict):
        # call base class __init__() function
        dict.__init__(self,theDict)
        # Build re object based on the keys of the dictionary
        self.regex = re.compile("|".join(map(re.escape,self.keys())))
        
    def __call__(self,match):
        """Handler invoked for each regex match """
        return self[match.group(0)]

    def xlat(self, text):
        """ Translate text, returns the modified text."""
        return self.regex.sub(self, text)
    
usage = '''%prog [options] config_file

required:
   config_file     a file containing all config variables '''

#########################################
####  main
#########################################
if __name__ == '__main__':
    
    cmdline = string.join(sys.argv)

    op = OptionParser(usage=usage)
    options,args = op.parse_args(sys.argv[1:])

    if len(args) != 1:
        op.print_help()
        sys.exit(1)

    # Read in the config file
    fh = open(args[0])
    configMod = importCode(fh,"config")
    fh.close()

    # Create the command line translator for the globals
    configMod.CLUSTER_GLOBALS["THISFILE"] = args[0]
    gxlator = Xlator(configMod.CLUSTER_GLOBALS)
    
    # Run the commands to generate the score file
    for cmdpat in configMod.SCORE_CMDS:
        cmd = gxlator.xlat(cmdpat)
        result = commands.getstatusoutput(cmd)
        if result[0] != 0:
            sys.exit("Error running: \n%s"%cmd)

    sys.exit(0)
    
